{****************************************************************************
 *             } Unit UKBD;{ (c) 1998 Michal Cihar                          *
 ****************************************************************************}

interface

procedure clearbuffer; {vyprazdni buffer}
procedure init_kbd; {nastavi jakesi standartni nastaveni (me vyhovuje)}
procedure reset_kbd; {resetne klavesnici}
procedure sleep_kbd; {uspi klavesnici}
procedure wake_kbd; {probudi klavesnici}
procedure set_led(caps,num,scroll:boolean); {nastavi ledky (jen ledky)}

procedure setscroll_lock(naco:boolean); {nastavi scroll lock}
procedure setnum_lock(naco:boolean); {nastavi num lock}
procedure setcaps_lock(naco:boolean); {nastavi caps lock}
procedure setinsert_status(naco:boolean); {nastavi insert}

function keypressed : boolean; {byla stiknuta klavesa?}
function read_key : word; {precte klavesu - (scancode shl 8)+ascii}
function readkey:char; {precte klavesu - char}
function tobuffer(ch:char):boolean; {vlozi do buffery znak ch}

{nasledujici procedury vraci stavy klaves,...}
function L_shift:boolean;
function R_shift:boolean;
function ctrlshift:boolean;
function altshift:boolean;
function scroll_lock:boolean;
function num_lock:boolean;
function caps_lock:boolean;
function insert_status:boolean;

function L_ctrlshift:boolean;
function L_altshift:boolean;
function printscreen_pressed:boolean;
function pause_status:boolean;
function scroll_lock_pressed:boolean;
function num_lock_pressed:boolean;
function caps_lock_pressed:boolean;
function insert_status_pressed:boolean;

implementation

uses dos;
var lastext:byte;
    stav1:byte absolute 0000:$0417;
    stav2:byte absolute 0000:$0418;
    r:registers;

procedure dummy;
begin;
end;

procedure init_kbd;
begin;
 asm
  mov al,0ffh
  out 60h,al
 end;
 r.ax:=$0305;
 r.bl:=0;
 r.bh:=0;
 intr($16,r);
end;

procedure set_led(caps,num,scroll:boolean);
var poslat:byte;
begin;
if caps then poslat:=4 else poslat:=0;
if num then poslat:=poslat+2;
if scroll then poslat:=poslat+1;
 asm
  mov al,0edh
  out 60h,al
 end;
 dummy;
 asm
  mov al,poslat
  out 60h,al
 end;
end;

procedure reset_kbd;assembler;
 asm
  mov al,0ffh
  out 60h,al
 end;

procedure sleep_kbd;assembler;
 asm
  mov al,0f5h
  out 60h,al
 end;

procedure wake_kbd;assembler;
 asm
  mov al,0f4h
  out 60h,al
 end;

function keypressed : boolean;assembler;
asm
   mov  ax, 40h
   mov  es, ax
   mov  dx, es:[1ah]
   mov  bx, es:[1ch]
   xor  ax, ax
   cmp  dx, bx
   je  @end
   mov  al, 1
 @end:
end;

procedure clearbuffer;assembler;
asm
   mov  ax, 40h
   mov  es, ax
   mov  ax, es:[1ch]
   mov  es:[1ah], ax
end;

function read_key : word;assembler;
asm
   mov  ax, 1000h
   int  16h
end;

function readkey:char;
var r:registers;
begin;
   if lastext=0 then
      begin;
      r.ah:=$00;
      intr($16,r);
      readkey:=chr(r.al);
      if r.al=0 then lastext:=r.ah else lastext:=0;
      end else
      begin;
      readkey:=chr(lastext);
      lastext:=0;
      end;
end;

function tobuffer(ch:char):boolean;
var r:registers;
begin;
   r.ah:=$05;
   r.cl:=ord(ch);
   r.ch:=0;
   intr($16,r);
   if r.al=0 then tobuffer:=true else tobuffer:=false;
end;


function L_shift:boolean;
begin;
 l_shift:=(stav1 and 2)=2;
end;

function R_shift:boolean;
begin;
 r_shift:=(stav1 and 1)=1;
end;

function ctrlshift:boolean;
begin;
 ctrlshift:=(stav1 and 4)=4;
end;

function altshift:boolean;
begin;
 altshift:=(stav1 and 8)=8;
end;

function scroll_lock:boolean;
begin;
 scroll_lock:=(stav1 and 16)=16;
end;

function num_lock:boolean;
begin;
 num_lock:=(stav1 and 32)=32;
end;

function caps_lock:boolean;
begin;
 caps_lock:=(stav1 and 64)=64;
end;

function insert_status:boolean;
begin;
 insert_status:=(stav1 and 128)=128;
end;

function L_ctrlshift:boolean;
begin;
 l_ctrlshift:=(stav2 and 1)=1;
end;

function L_altshift:boolean;
begin;
 l_altshift:=(stav2 and 2)=2;
end;

function printscreen_pressed:boolean;
begin;
 printscreen_pressed:=(stav2 and 4)=4;
end;

function pause_status:boolean;
begin;
 pause_status:=(stav2 and 8)=8;
end;

function scroll_lock_pressed:boolean;
begin;
 scroll_lock_pressed:=(stav2 and 16)=16;
end;

function num_lock_pressed:boolean;
begin;
 num_lock_pressed:=(stav2 and 32)=32;
end;

function caps_lock_pressed:boolean;
begin;
 caps_lock_pressed:=(stav2 and 64)=64;
end;

function insert_status_pressed:boolean;
begin;
 insert_status_pressed:=(stav2 and 128)=128;
end;

procedure setscroll_lock(naco:boolean);
begin;
 if not(((stav1 and 16)=16)=naco) then
    if naco then stav1:=stav1+16 else stav1:=stav1-16;
 if naco then set_led(caps_lock,num_lock,true) else set_led(caps_lock,num_lock,false);
end;

procedure setnum_lock(naco:boolean);
begin;
 if not(((stav1 and 32)=32)=naco) then
    if naco then stav1:=stav1+32 else stav1:=stav1-32;
 if naco then set_led(caps_lock,true,scroll_lock) else set_led(caps_lock,false,scroll_lock);
end;

procedure setcaps_lock(naco:boolean);
begin;
 if not(((stav1 and 64)=64)=naco) then
    if naco then stav1:=stav1+64 else stav1:=stav1-64;
 if naco then set_led(true,num_lock,scroll_lock) else set_led(false,num_lock,scroll_lock);
end;

procedure setinsert_status(naco:boolean);
begin;
 if not(((stav1 and 125)=128)=naco) then
    if naco then stav1:=stav1+128 else stav1:=stav1-128;
end;

begin;
  lastext:=0;
end.